# coding: utf-8

"""
AskUI Workspaces API

No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

The version of the OpenAPI document: 0.1.30
Generated by OpenAPI Generator (https://openapi-generator.tech)

Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations

import json
import pprint
from typing import Any, Dict, Optional, Set, Union

from pydantic import (
    BaseModel,
    ConfigDict,
    ValidationError,
    field_validator,
)
from typing_extensions import Self

from askui.tools.askui.askui_workspaces.models.data_destination_ask_ui_workflow_create import (
    DataDestinationAskUiWorkflowCreate,
)
from askui.tools.askui.askui_workspaces.models.data_destination_webhook_create import (
    DataDestinationWebhookCreate,
)

AGENTCREATECOMMANDDATADESTINATIONSINNER_ONE_OF_SCHEMAS = [
    "DataDestinationAskUiWorkflowCreate",
    "DataDestinationWebhookCreate",
]


class AgentCreateCommandDataDestinationsInner(BaseModel):
    """
    AgentCreateCommandDataDestinationsInner
    """

    # data type: DataDestinationAskUiWorkflowCreate
    oneof_schema_1_validator: Optional[DataDestinationAskUiWorkflowCreate] = None
    # data type: DataDestinationWebhookCreate
    oneof_schema_2_validator: Optional[DataDestinationWebhookCreate] = None
    actual_instance: Optional[
        Union[DataDestinationAskUiWorkflowCreate, DataDestinationWebhookCreate]
    ] = None
    one_of_schemas: Set[str] = {
        "DataDestinationAskUiWorkflowCreate",
        "DataDestinationWebhookCreate",
    }

    model_config = ConfigDict(
        validate_assignment=True,
        protected_namespaces=(),
    )

    discriminator_value_class_map: Dict[str, str] = {}

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError(
                    "If a position argument is used, only 1 is allowed to set `actual_instance`"
                )
            if kwargs:
                raise ValueError(
                    "If a position argument is used, keyword arguments cannot be used."
                )
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator("actual_instance")
    def actual_instance_must_validate_oneof(cls, v):
        instance = AgentCreateCommandDataDestinationsInner.model_construct()
        error_messages = []
        match = 0
        # validate data type: DataDestinationAskUiWorkflowCreate
        if not isinstance(v, DataDestinationAskUiWorkflowCreate):
            error_messages.append(
                f"Error! Input type `{type(v)}` is not `DataDestinationAskUiWorkflowCreate`"
            )
        else:
            match += 1
        # validate data type: DataDestinationWebhookCreate
        if not isinstance(v, DataDestinationWebhookCreate):
            error_messages.append(
                f"Error! Input type `{type(v)}` is not `DataDestinationWebhookCreate`"
            )
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError(
                "Multiple matches found when setting `actual_instance` in AgentCreateCommandDataDestinationsInner with oneOf schemas: DataDestinationAskUiWorkflowCreate, DataDestinationWebhookCreate. Details: "
                + ", ".join(error_messages)
            )
        if match == 0:
            # no match
            raise ValueError(
                "No match found when setting `actual_instance` in AgentCreateCommandDataDestinationsInner with oneOf schemas: DataDestinationAskUiWorkflowCreate, DataDestinationWebhookCreate. Details: "
                + ", ".join(error_messages)
            )
        return v

    @classmethod
    def from_dict(cls, obj: Union[str, Dict[str, Any]]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        match = 0

        # use oneOf discriminator to lookup the data type
        _data_type = json.loads(json_str).get("type")
        if not _data_type:
            raise ValueError(
                "Failed to lookup data type from the field `type` in the input."
            )

        # check if data type is `DataDestinationAskUiWorkflowCreate`
        if _data_type == "ASKUI_WORKFLOW":
            instance.actual_instance = DataDestinationAskUiWorkflowCreate.from_json(
                json_str
            )
            return instance

        # check if data type is `DataDestinationWebhookCreate`
        if _data_type == "WEBHOOK":
            instance.actual_instance = DataDestinationWebhookCreate.from_json(json_str)
            return instance

        # check if data type is `DataDestinationAskUiWorkflowCreate`
        if _data_type == "DataDestinationAskUiWorkflowCreate":
            instance.actual_instance = DataDestinationAskUiWorkflowCreate.from_json(
                json_str
            )
            return instance

        # check if data type is `DataDestinationWebhookCreate`
        if _data_type == "DataDestinationWebhookCreate":
            instance.actual_instance = DataDestinationWebhookCreate.from_json(json_str)
            return instance

        # deserialize data into DataDestinationAskUiWorkflowCreate
        try:
            instance.actual_instance = DataDestinationAskUiWorkflowCreate.from_json(
                json_str
            )
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into DataDestinationWebhookCreate
        try:
            instance.actual_instance = DataDestinationWebhookCreate.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError(
                "Multiple matches found when deserializing the JSON string into AgentCreateCommandDataDestinationsInner with oneOf schemas: DataDestinationAskUiWorkflowCreate, DataDestinationWebhookCreate. Details: "
                + ", ".join(error_messages)
            )
        if match == 0:
            # no match
            raise ValueError(
                "No match found when deserializing the JSON string into AgentCreateCommandDataDestinationsInner with oneOf schemas: DataDestinationAskUiWorkflowCreate, DataDestinationWebhookCreate. Details: "
                + ", ".join(error_messages)
            )
        return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(
            self.actual_instance.to_json
        ):
            return self.actual_instance.to_json()
        return json.dumps(self.actual_instance)

    def to_dict(
        self,
    ) -> Optional[
        Union[
            Dict[str, Any],
            DataDestinationAskUiWorkflowCreate,
            DataDestinationWebhookCreate,
        ]
    ]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(
            self.actual_instance.to_dict
        ):
            return self.actual_instance.to_dict()
        # primitive type
        return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())
