# coding: utf-8

"""
AskUI Workspaces API

No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

The version of the OpenAPI document: 0.1.30
Generated by OpenAPI Generator (https://openapi-generator.tech)

Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations

import json
import pprint
from typing import Any, Dict, Optional, Set, Union

from pydantic import (
    BaseModel,
    ConfigDict,
    ValidationError,
    field_validator,
)
from typing_extensions import Self

from askui.tools.askui.askui_workspaces.models.file_dto import FileDto
from askui.tools.askui.askui_workspaces.models.folder_dto import FolderDto

FILESLISTRESPONSEDTODATAINNER_ONE_OF_SCHEMAS = ["FileDto", "FolderDto"]


class FilesListResponseDtoDataInner(BaseModel):
    """
    FilesListResponseDtoDataInner
    """

    # data type: FileDto
    oneof_schema_1_validator: Optional[FileDto] = None
    # data type: FolderDto
    oneof_schema_2_validator: Optional[FolderDto] = None
    actual_instance: Optional[Union[FileDto, FolderDto]] = None
    one_of_schemas: Set[str] = {"FileDto", "FolderDto"}

    model_config = ConfigDict(
        validate_assignment=True,
        protected_namespaces=(),
    )

    discriminator_value_class_map: Dict[str, str] = {}

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError(
                    "If a position argument is used, only 1 is allowed to set `actual_instance`"
                )
            if kwargs:
                raise ValueError(
                    "If a position argument is used, keyword arguments cannot be used."
                )
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator("actual_instance")
    def actual_instance_must_validate_oneof(cls, v):
        instance = FilesListResponseDtoDataInner.model_construct()
        error_messages = []
        match = 0
        # validate data type: FileDto
        if not isinstance(v, FileDto):
            error_messages.append(f"Error! Input type `{type(v)}` is not `FileDto`")
        else:
            match += 1
        # validate data type: FolderDto
        if not isinstance(v, FolderDto):
            error_messages.append(f"Error! Input type `{type(v)}` is not `FolderDto`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError(
                "Multiple matches found when setting `actual_instance` in FilesListResponseDtoDataInner with oneOf schemas: FileDto, FolderDto. Details: "
                + ", ".join(error_messages)
            )
        if match == 0:
            # no match
            raise ValueError(
                "No match found when setting `actual_instance` in FilesListResponseDtoDataInner with oneOf schemas: FileDto, FolderDto. Details: "
                + ", ".join(error_messages)
            )
        return v

    @classmethod
    def from_dict(cls, obj: Union[str, Dict[str, Any]]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        match = 0

        # use oneOf discriminator to lookup the data type
        _data_type = json.loads(json_str).get("type")
        if not _data_type:
            raise ValueError(
                "Failed to lookup data type from the field `type` in the input."
            )

        # check if data type is `FileDto`
        if _data_type == "file":
            instance.actual_instance = FileDto.from_json(json_str)
            return instance

        # check if data type is `FolderDto`
        if _data_type == "folder":
            instance.actual_instance = FolderDto.from_json(json_str)
            return instance

        # check if data type is `FileDto`
        if _data_type == "FileDto":
            instance.actual_instance = FileDto.from_json(json_str)
            return instance

        # check if data type is `FolderDto`
        if _data_type == "FolderDto":
            instance.actual_instance = FolderDto.from_json(json_str)
            return instance

        # deserialize data into FileDto
        try:
            instance.actual_instance = FileDto.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into FolderDto
        try:
            instance.actual_instance = FolderDto.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError(
                "Multiple matches found when deserializing the JSON string into FilesListResponseDtoDataInner with oneOf schemas: FileDto, FolderDto. Details: "
                + ", ".join(error_messages)
            )
        if match == 0:
            # no match
            raise ValueError(
                "No match found when deserializing the JSON string into FilesListResponseDtoDataInner with oneOf schemas: FileDto, FolderDto. Details: "
                + ", ".join(error_messages)
            )
        return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(
            self.actual_instance.to_json
        ):
            return self.actual_instance.to_json()
        return json.dumps(self.actual_instance)

    def to_dict(self) -> Optional[Union[Dict[str, Any], FileDto, FolderDto]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(
            self.actual_instance.to_dict
        ):
            return self.actual_instance.to_dict()
        # primitive type
        return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())
